#ifndef __EXCEPTION_H__
#define __EXCEPTION_H__

class CommandLineOptions;

class Exception
{
public:
	virtual std::string What() const = 0;
};

class CommandLineException
	: public Exception
{
public:
	CommandLineException(const std::string& strError, const CommandLineOptions& rOptions)
		: m_rOptions(rOptions), m_strError(strError)
	{
	}

	virtual std::string What() const;

private:
	
	std::string					m_strError;
	const CommandLineOptions&	m_rOptions;
};

#endif